var HTTPClass = "tk/zeitheron/hammerlib/asm/HTTPHook";
var HTTPMethod = "handleSuitableLanPort";

function initializeCoreMod()
{
	return {
		'coremodone': {
			'target': { 'type': 'CLASS', 'name': 'net.minecraft.util.HTTPUtil' },
			'transformer': function(classNode)
			{
				var Opcodes = Java.type('org.objectweb.asm.Opcodes');
				print("[HammerLib] Transforming HTTPUtil!");
				var MethodInsnNode = Java.type('org.objectweb.asm.tree.MethodInsnNode');
				var InsnNode = Java.type('org.objectweb.asm.tree.InsnNode');
				var methods = classNode.methods;
				for(m in methods)
				{
					var method = methods[m];
					if(method.name.equals("getSuitableLanPort") || method.name.equals("func_76181_a"))
					{
						var code = method.instructions;
						code.insertBefore(code.getFirst(), new InsnNode(Opcodes.IRETURN));
						code.insertBefore(code.getFirst(), new MethodInsnNode(Opcodes.INVOKESTATIC, HTTPClass, HTTPMethod, method.desc, false));
					}
				}

				return classNode;
			}
		}
	}
}