var hookClass = "tk/zeitheron/hammerlib/asm/EntityHook";
var itemUseFinish = "onItemUseFinish";

function initializeCoreMod()
{
	return {
		'coremodone': {
			'target': { 'type': 'CLASS', 'name': 'net.minecraft.entity.LivingEntity' },
			'transformer': function(classNode)
			{
				var Opcodes = Java.type('org.objectweb.asm.Opcodes');
				print("[HammerLib] Transforming LivingEntity!");
				var MethodInsnNode = Java.type('org.objectweb.asm.tree.MethodInsnNode');
				var VarInsnNode = Java.type('org.objectweb.asm.tree.VarInsnNode');
				var methods = classNode.methods;
				for(m in methods)
				{
					var method = methods[m];
					if(method.name.equals("onItemUseFinish") || method.name.equals("func_71036_o"))
					{
						var code = method.instructions;
						code.insertBefore(code.getFirst(), new MethodInsnNode(Opcodes.INVOKESTATIC, hookClass, itemUseFinish, "(L" + classNode.name + ";)V", false));
						code.insertBefore(code.getFirst(), new VarInsnNode(Opcodes.ALOAD, 0));
					}
				}

				return classNode;
			}
		}
	}
}